*\
*\  As far as I know, this is the first TRUE browse.  By TRUE I mean that
*\  there is no function outside of the SF_BROWSE() function controling
*\  the display and the SF_BROWSE() function doesn't need to know the
*\  structure of the DBF file.
*\
*\  This function is basically in Pre-Alpha,,, I just thought everyone could
*\  use this long awaited function.  The final version of SF_BROWSE() will
*\  become part of the Special Forces CUA Library of which you can download
*\  the shareware version from the BBS's area 10.
*\
*\  Mark Witten
*\

#include database.hdr
#include system.hdr
#include io.hdr
#include fileio.hdr
#include string.hdr

#pragma w_func_proc-

dbfdef cpcsusp
  char( 10 ) idnumber
  char( 15 ) firstname
  char( 15 ) lastname
  char( 10 ) fbinumber
  char( 10 ) sidnumber
  char( 10 ) add1_num
  char( 10 ) add2_num
  char( 10 ) add3_num
  char( 10 ) add4_num
  char( 15 ) middle
  char( 11 ) ssnumber
  date       birthdate
  char( 25 ) c_add1
  char( 25 ) c_add2
  char( 20 ) c_city
  char( 2 )  c_state
  char( 10 ) c_zip
  char( 25 ) p_add1
  char( 25 ) p_add2
  char( 20 ) p_city
  char( 2 )  p_state
  char( 10 ) p_zip
  char( 25 ) employ1
  char( 20 ) filter
  char( 25 ) occupation
  char( 15 ) alias1
  char( 15 ) alias2
  char( 15 ) alias3
  int( 3 )   points
enddef

function long sf_browse prototype
  parameters const char file_name,;                 && DBF file path+name
             alias browse_alias,;                   && Alias
             value int lr,;                         && Screen cords...
             value int lc,;
             value int rr,;
             value int rc,;
             const char( 11 ) field_array[ 0 ],;    && EXACT array of fields
             const char header_array[ 0 ],;         && Array of field headers
             value int max_fields,;                 && Total fields requested
             const logical display_only,;           && Like pick_list()
             const char field_delimit,;             && Field separator
             value byte window_std,;                && Browse __color_std
             value byte window_enhcd,;              && Browse __color_enhcd
             value byte header_std                  && Header __color_std

procedure force_main
  vardef
    char( 11 ) field_array[ 29 ]
    char       header_array[ 29 ]
    int        max_fields
  enddef
  more_handles()

  *\ IMPORTANT: Array must be all caps and exactly char( 11 ) long.
  *\            The fields may be of any number and in any order
  *\            the programmer wishes.

  field_array[ 00 ] = "IDNUMBER   "
  field_array[ 01 ] = "FIRSTNAME  "
  field_array[ 02 ] = "LASTNAME   "
  field_array[ 03 ] = "FBINUMBER  "
  field_array[ 04 ] = "SIDNUMBER  "
  field_array[ 05 ] = "ADD1_NUM   "
  field_array[ 06 ] = "ADD2_NUM   "
  field_array[ 07 ] = "ADD3_NUM   "
  field_array[ 08 ] = "ADD4_NUM   "
  field_array[ 09 ] = "MIDDLE     "
  field_array[ 10 ] = "SSNUMBER   "
  field_array[ 11 ] = "BIRTHDATE  "
  field_array[ 12 ] = "C_ADD1     "
  field_array[ 13 ] = "C_ADD2     "
  field_array[ 14 ] = "C_CITY     "
  field_array[ 15 ] = "C_STATE    "
  field_array[ 16 ] = "C_ZIP      "
  field_array[ 17 ] = "P_ADD1     "
  field_array[ 18 ] = "P_ADD2     "
  field_array[ 19 ] = "P_CITY     "
  field_array[ 20 ] = "P_STATE    "
  field_array[ 21 ] = "P_ZIP      "
  field_array[ 22 ] = "EMPLOY1    "
  field_array[ 23 ] = "FILTER     "
  field_array[ 24 ] = "OCCUPATION "
  field_array[ 25 ] = "ALIAS1     "
  field_array[ 26 ] = "ALIAS2     "
  field_array[ 27 ] = "ALIAS3     "
  field_array[ 28 ] = "POINTS     "

  *\ This array makes up the header for each of the fields defined above.
  *\ As you can see, the length is not important.

  header_array[ 00 ] = "Id #"
  header_array[ 01 ] = "First Name"
  header_array[ 02 ] = "Last Name"
  header_array[ 03 ] = "Fbi #"
  header_array[ 04 ] = "Sid #"
  header_array[ 05 ] = "Add'l #1"
  header_array[ 06 ] = "Add'l #2"
  header_array[ 07 ] = "Add'l #3"
  header_array[ 08 ] = "Add'l #4"
  header_array[ 09 ] = "Middle"
  header_array[ 10 ] = "SS. #"
  header_array[ 11 ] = "D.O.B."
  header_array[ 12 ] = "Current"
  header_array[ 13 ] = "Address"
  header_array[ 14 ] = "City"
  header_array[ 15 ] = "St"
  header_array[ 16 ] = "Zip-Code"
  header_array[ 17 ] = "Prior"
  header_array[ 18 ] = "Address"
  header_array[ 19 ] = "City"
  header_array[ 20 ] = "St"
  header_array[ 21 ] = "Zip-Code"
  header_array[ 22 ] = "EMPLOY1"
  header_array[ 23 ] = "Filter"
  header_array[ 24 ] = "Occupation"
  header_array[ 25 ] = "Alias #1"
  header_array[ 26 ] = "Alias #2"
  header_array[ 27 ] = "Alias #3"
  header_array[ 28 ] = "Pts"

  *\ Open the file etc...
  open "suspd000.dbf" alias cpcsusp
  clear
  cursor_off()

  *\ This is the defined array size
  max_fields = 29

  *\ And do it...
  ? sf_browse( "suspd000.dbf", cpcsusp, 05, 10, 20, 60,;
             field_array[], header_array[], max_fields,;
             .f., chr( 179 ), 31, 007, 112 )

  wait "Waiting for you to view the return..."
  cursor_on()
  close( cpcsusp )
endpro
